/************************************************************************************************
*
*	Contributed by Abir Majumdar at Macrovision.
*
*	This custom code action takes a comma-separated list (no spaces) of integer values and 
*	adds it to the required disk space.  This is especially useful for projects using merge
*	modules that installed a whole bunch of files to an install.  Normally InstallAnywhere 
*	installers account for disk space of merge modules, but not for installers generating a 
*	lot of additional files with their scripts.  This custom code makes it really easy for 
*	people to add to the required disk space of an installer and does some math.
*
************************************************************************************************/

package com.zerog.ia.customcode.actions;

import com.zerog.ia.api.pub.*;
import java.io.PrintStream;
import java.util.StringTokenizer;
import java.util.Vector;

public class AddToRequiredDiskSpace extends CustomCodeAction
{

    public AddToRequiredDiskSpace()
    {
    }

    public void install(InstallerProxy ip)
        throws InstallException
    {
        String variableList = ip.substitute("$ADDITIONAL_DISK_SPACE_VARIABLE_LIST$");
        StringTokenizer vlTokenizer = new StringTokenizer(ip.substitute(variableList), ",");
        Vector diskSpaceVector = new Vector();
        Integer diskSpaceVariable;
        for(; vlTokenizer.hasMoreTokens(); diskSpaceVector.add(diskSpaceVariable))
            diskSpaceVariable = new Integer(vlTokenizer.nextToken());

        int sumToAdd = 0;
        for(int i = 0; i < diskSpaceVector.size(); i++)
        {
            Integer diskSpaceVectorInteger = (Integer)diskSpaceVector.elementAt(i);
            sumToAdd += diskSpaceVectorInteger.intValue();
            System.err.println("sumToAdd: " + sumToAdd);
        }

        System.err.println("Final sumToAdd: " + sumToAdd);
        ip.setVariable("DEVELOPER_DISK_SPACE_ADDITIONAL", (new Integer(sumToAdd)).toString());
    }

    public void uninstall(UninstallerProxy uninstallerproxy)
        throws InstallException
    {
    }

    public String getInstallStatusMessage()
    {
        return "";
    }

    public String getUninstallStatusMessage()
    {
        return "";
    }
}
